#include "mem_func.h"
#include "sem_func.h"
#include <time.h>

int main(int argc, char const *argv[])
{
    const int id_sem=atoi(argv[1]);
    const int mem_id=atoi(argv[2]);

    char buf[UNIT_SIZE];    //bufor dla write()

    int bytes_read=0;
    int bytes_written=0;

    int sleepValue;

    const int file2=open(argv[3], O_WRONLY|O_CREAT, 0644);
    if(file2==-1)
    {
        perror("Blad funkcji open() - proc. konsumenta\n");
        exit(9);
    }

    printf("Consumer.x: ");
    Towar *bufor;
    bufor=(Towar*) memAtt(mem_id, O_RDONLY);

    setValue(id_sem, SEM1, FULL);

    bufor->begin=FIRST;  //0
    bufor->end=FIRST;    //0

    srand(time(NULL));

    do
    {
        sleepValue=(rand()%MAX)+MIN;

        down(id_sem, SEM1);
        sleep(sleepValue);
        
        strcpy(buf, bufor->share[bufor->begin]);

        printf("Proces konsumenta: %s\n", buf);
        //printf("Proces konsumenta: %s\n", bufor->share[bufor->begin]);

        bytes_read=strlen(buf);
        //if (bytes_read==0) break;

        bufor->begin=(bufor->begin+1)%MEM_SIZE;

        up(id_sem, SEM0);

        bytes_written=0;

        do
        {
            ssize_t ret=write(file2, buf+bytes_written, bytes_read-bytes_written);
            if(ret==-1)
            {
                perror("Blad funkcji write() w procesie konsumenta\n");
                exit(19);
            }

            bytes_written+=ret;
        }while(bytes_read>bytes_written);

    }while(bytes_read>0);

    if(close(file2)==-1)
    {
        perror("Blad funkcji close() - proces konsumenta\n");
        exit(11);
    }

    delAtt(bufor);

    return 0;
}
